#!/bin/bash

#NASTAVENIE PREMENNYCH
#TESTED_PROGRAM=$1
TESTED_PROGRAM=u1-1

TESTED_PROGRAM_OUTPUT=tested_program_output.txt
STRACE_OUTPUT="strace_out.txt"


PASSED_MSG="OK"
NUMBER_OF_STEPS=1
CURRENT_STEP=0
PASSED_STEPS=0

echo "Testovanie ulohy u1_1 z cvicenia 2"
echo

#PRIPRAVA SUBOROV




#SPUSTENIE TESTOVANEHO PROGRAMU - ZISKANIE VYPISU VOLANYCH SLUZIEB
strace -e openat -o $STRACE_OUTPUT ./$TESTED_PROGRAM file_as_argument.txt > $TESTED_PROGRAM_OUTPUT 2>&1

#PRIPRAVA TESTOV
test(){
((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie zavolania sluzby open()"
if grep -q "^openat(AT_FDCWD, \"file_as_argument.txt\", O_RDONLY)" $STRACE_OUTPUT; then
	echo "OK - Sluzba open() bola zavolana so spravnymi parametrami."
	((PASSED_STEPS+=1))
else	
	echo "CHYBA - Sluzba open() nebola zavolana alebo jej boli zadane nespravne parametre."
	return 1
fi
}

#ZAVOLANIE TESTU
test

#MAZANIE VYTVORENYCH SUBOROV


#VYHODNOTENIE TESTU
echo
echo Vysledok testovania
echo "Uspesne bolo vykonanych $PASSED_STEPS / $NUMBER_OF_STEPS testov."


